***********************************************************************
* Program....: SETUPDCL.PRG
* Compiler...: Visual FoxPro 07.00.0000.9262 for Windows 
* Purpose....: Data Class Environment Setup Program
***********************************************************************
CLOSE DATABASES ALL
CLEAR
LOCAL lcPath
***************************************************
*** Start with the Path
***************************************************
*** This is Dev Mode - Full Path required 
lcPath = (HOME() + ";" ) + (FULLPATH( CURDIR() ) + ";METADATA;DATA")
SET PATH TO (lcPath)
*** Note there are several ASSERT statements in the Data Classes, 
*** especially when things go wrong (like updates failing) because
*** they give you the opportunity to go into DEBUG mode right there.
*** If you want to disable them, just SET ASSERTS OFF instead
SET ASSERTS ON
*** And set the variable which makes data classes copy SQL to clipboard
RELEASE glCopySQL
PUBLIC glCopySQL
glCopySQL = .T.
***************************************************
*** Now we should be able to open the class libraries without errors
***************************************************
SET CLASSLIB TO ..\rootclass, ..\genforms, ..\basectrl ADDITIVE
***************************************************
*** And the Procedure files
***************************************************
SET PROCEDURE TO dataclass, dsetbase ADDITIVE
***************************************************
*** We need to add the Data Manager and Connect to SQL Server
*** So make sure we have the _Screen property
***************************************************
IF NOT PEMSTATUS( _Screen, 'oDM', 5 )
    _Screen.AddProperty( 'oDM', NULL )
ENDIF
***************************************************
*** Add the Data Manager and Connect. Check for success
***************************************************
_Screen.oDM = CREATEOBJECT( 'xDatMgr', 'VFPDClas' )
IF VARTYPE( _Screen.oDM ) = "O"
    *** We have the Data Manager, but did it connect?
    lnCon = _Screen.oDm.GetHandle( 'VFP' )
    IF lnCon < 1
        MESSAGEBOX( 'Cannot Connect using VFPDClas', 16, 'Setup Error' )
        RETURN
    ENDIF
    *** OK, now add the SQL Connection

    _Screen.oDM.AddConnection( 'SQLDClas' )
    lnCon = _Screen.oDm.GetHandle( 'SQL' )
    IF lnCon < 1
        MESSAGEBOX( 'Cannot Connect using SQLDClas', 16, 'Setup Error' )
        RETURN
    ENDIF
ELSE
    MESSAGEBOX( 'Cannot create the Data Manager', 16, 'Fatal Setup Error' )
    RETURN
ENDIF
