using System;
using System.IO;
using System.Data;
using System.Data.SqlClient;
using System.Xml;
using System.Reflection;

// *** Namespace you'll need for COM Interop
using System.Runtime.InteropServices;
using Westwind.Tools;
using System.Threading;


namespace DotNetCOM
{

[ClassInterface(ClassInterfaceType.AutoDual)]
[ComSourceInterfaces( typeof(IMultiThreadedComLauncherEvents) )]
[ProgId("DotNetCom.MultiThreadedComLauncher")]	
public class MultiThreadedComLauncher
{
	public string ProgId = "";
	public string Method = "";
	public object Parameter = null;

	public event ThreadStart ThreadCompleted;

	public void RunMultiThreadedCom(string ProgId,string Method, object Parameter)
	{
		this.ProgId =  ProgId;
		this.Method = Method;
		this.Parameter = Parameter;

		Thread Worker = new Thread(
			new ThreadStart(this.RunMultiThreadedCom_ThreadMethod) );

		// Important for VFP components!
		Worker.ApartmentState = ApartmentState.STA;
		Worker.Start();
	}

	private void RunMultiThreadedCom_ThreadMethod()
	{
		Type ComType = Type.GetTypeFromProgID(this.ProgId);
		object ComObj =  Activator.CreateInstance(ComType);
		ComUtils.CallMethod(ComObj,this.Method,this.Parameter);

		if (this.ThreadCompleted != null)
			this.ThreadCompleted();
	}
}


[InterfaceType(ComInterfaceType.InterfaceIsIDispatch)]
public interface IMultiThreadedComLauncherEvents
{
	[DispId(1)]void ThreadCompleted();
}

}