using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;



namespace Westwind.Windows.Dialogs
{
	/// <summary>
	/// Summary description for DownloadFile.
	/// </summary>
	public class ProgressForm : System.Windows.Forms.Form
	{
		protected System.Windows.Forms.PictureBox picImage;
		private System.Windows.Forms.Button btnCancel;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.ProgressBar Progress;

		protected System.Windows.Forms.Label lblMessage;
		protected System.Windows.Forms.Label lblHeader;

		private DateTime StartTime = DateTime.Now;
		private int CurrentPercent = 0;

		public bool Cancelled
		{
			get { return this.bCancelled; }
			set { this.bCancelled = value; }
		}
		bool bCancelled = false;

		public bool ShowTimeLeft
		{
			get { return this.bShowTimeLeft; }
			set { this.bShowTimeLeft = value; }
		}
		bool bShowTimeLeft = true; 

		public string Header
		{
			get { return this.cHeader; }
			set { this.cHeader = value; 
			      this.lblHeader.Text = value;}
		}
		string cHeader = "Processing...";

		public string Message
		{
			get { return this.cMessage; }
			set { this.cMessage = value; }
		}
		string cMessage;

		public bool ShowCancelButton
		{
			get { return this.btnCancel.Visible; }
			set { this.btnCancel.Visible = value; }
		}
		public string ErrorMessage
		{
			get
			{
				return _ErrorMessage;
			}
			set
			{
				_ErrorMessage = value;
			}
		}
		private string _ErrorMessage = "";

		public ProgressForm()
		{
			InitializeComponent();

		}
		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(ProgressForm));
			this.btnCancel = new System.Windows.Forms.Button();
			this.Progress = new System.Windows.Forms.ProgressBar();
			this.lblMessage = new System.Windows.Forms.Label();
			this.lblHeader = new System.Windows.Forms.Label();
			this.picImage = new System.Windows.Forms.PictureBox();
			this.SuspendLayout();
			// 
			// btnCancel
			// 
			this.btnCancel.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnCancel.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnCancel.Location = new System.Drawing.Point(320, 80);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.Size = new System.Drawing.Size(80, 25);
			this.btnCancel.TabIndex = 1;
			this.btnCancel.Text = "&Cancel";
			this.btnCancel.Click += new System.EventHandler(this.btnCancel_Click);
			// 
			// Progress
			// 
			this.Progress.Location = new System.Drawing.Point(8, 55);
			this.Progress.Name = "Progress";
			this.Progress.Size = new System.Drawing.Size(391, 16);
			this.Progress.Step = 2;
			this.Progress.TabIndex = 2;
			// 
			// lblMessage
			// 
			this.lblMessage.BackColor = System.Drawing.Color.Transparent;
			this.lblMessage.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblMessage.Location = new System.Drawing.Point(8, 79);
			this.lblMessage.Name = "lblMessage";
			this.lblMessage.Size = new System.Drawing.Size(304, 48);
			this.lblMessage.TabIndex = 3;
			// 
			// lblHeader
			// 
			this.lblHeader.BackColor = System.Drawing.Color.Transparent;
			this.lblHeader.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblHeader.Location = new System.Drawing.Point(56, 16);
			this.lblHeader.Name = "lblHeader";
			this.lblHeader.Size = new System.Drawing.Size(336, 24);
			this.lblHeader.TabIndex = 4;
			this.lblHeader.TextAlign = System.Drawing.ContentAlignment.BottomLeft;
			// 
			// picImage
			// 
			this.picImage.Image = ((System.Drawing.Image)(resources.GetObject("picImage.Image")));
			this.picImage.Location = new System.Drawing.Point(16, 11);
			this.picImage.Name = "picImage";
			this.picImage.Size = new System.Drawing.Size(32, 32);
			this.picImage.TabIndex = 5;
			this.picImage.TabStop = false;
			// 
			// ProgressForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 14);
			this.ClientSize = new System.Drawing.Size(408, 133);
			this.Controls.Add(this.lblHeader);
			this.Controls.Add(this.lblMessage);
			this.Controls.Add(this.Progress);
			this.Controls.Add(this.btnCancel);
			this.Controls.Add(this.picImage);
			this.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.Name = "ProgressForm";
			this.ShowInTaskbar = false;
			this.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Hide;
			this.Text = "Processing";
			this.TopMost = true;
			this.ResumeLayout(false);

		}
		#endregion

		private void btnCancel_Click(object sender, System.EventArgs e)
		{
			this.Cancel();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		public void Increment(int Increment) 
		{
			this.UpdateStatus(this.CurrentPercent + Increment);
		}

		public void UpdateStatus(int Percent) 
		{
			this.UpdateStatus(null,Percent);
		}
		public void UpdateStatus(string Message) 
		{
			this.UpdateStatus(Message,-1);
		}
		public void UpdateStatus(string Message, int Percent) 
		{
			this.CurrentPercent = Percent;

			if (Message != null) 
			{
				this.lblMessage.Text = Message;
				this.lblMessage.Refresh();
			}

			if (this.ShowTimeLeft)
				this.SetCompletionTimeMessage();	
			
			if (Percent > -1)
				this.Progress.Value = Percent;

			this.Refresh(); //Progress.Refresh();
		}

		public void Cancel()
		{
			this.Cancelled = true;
			this.Close();
		}	

		private void SetCompletionTimeMessage() 
		{
			if (this.CurrentPercent > 99.99)
			{
				this.lblMessage.Text = "Download Completed";
				return;
			}

			TimeSpan Span = DateTime.Now.Subtract(this.StartTime);
			int Seconds = Span.Seconds;
            float t = ((float) Seconds *  (100.00F/ (float) this.CurrentPercent));
			int SecondsToGo =   (int) t - Seconds + 1;	

			if (SecondsToGo > 10000)
			{;}
			else if (SecondsToGo > 120)
				this.lblMessage.Text = this.lblMessage.Text + "\r\n" +
					((int) (SecondsToGo/60)).ToString() + " minutes remaining...";
			else
				this.lblMessage.Text = this.lblMessage.Text + "\r\n" +
					"Approximately " + SecondsToGo.ToString() + " seconds remaining...";
		}

		/// <summary>
		/// Add an image at the top of the form
		/// </summary>
		/// <param name="Image"></param>
		public void AddImage(Bitmap Image) 
		{
			if (Image == null)
				this.lblHeader.Left = this.picImage.Left;
			else 
			{
				if (Image.Height > 40)  
				{
					// *** Resize the image
					float Ratio = 40.00F / Image.Height;
					int Width = (int) ((float) Image.Width * Ratio);

					Bitmap NewImage = new Bitmap(Image,Width,40);
					Image.Dispose();
					Image = NewImage;
					NewImage = null;
				}

				this.picImage.Height = Image.Height;
				this.picImage.Width = Image.Width;

				this.picImage.Image = Image;

				this.lblHeader.Left = this.picImage.Left + this.picImage.Width + 5;
				this.picImage.Visible = true;
				this.picImage.Update();
			}
		}

	
		public virtual void AddImage(string ImageFileName) 
		{
			if (System.IO.File.Exists(ImageFileName) )
			{
				this.picImage.Image = System.Drawing.Image.FromFile(ImageFileName);
				this.lblHeader.Left = this.picImage.Left + this.picImage.Width + 5;
				this.Refresh();
			}
		}

	}
}
