using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using System.Threading;
using System.Runtime.InteropServices;

using Westwind.Tools;
using System.Reflection;

namespace DotNetCOM
{
	/// <summary>
	/// Summary description for WindowsFormSample.
	/// </summary>
	[ClassInterface(ClassInterfaceType.AutoDual)]
	[ProgId("DotNetCom.WinFormCom")]
	public class WinFormCom : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button btnSayHello;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		private System.Windows.Forms.StatusBar Status;
		private System.Windows.Forms.StatusBarPanel Panel1;
		private Westwind.Windows.wwTextBox txtMessage;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private Westwind.Windows.wwTextBox txtCompany;
		private System.Windows.Forms.Label label3;
		private Westwind.Windows.wwTextBox txtPhone;
		private System.Windows.Forms.Label label4;
		private Westwind.Windows.wwTextBox txtAddress;
		private System.Windows.Forms.Label label5;
		private Westwind.Windows.wwTextBox txtCreditLimit;
		private System.Windows.Forms.Button cmdSave;

		private Westwind.Windows.wwTextBox txtName;
		private System.Windows.Forms.Label label6;
		private Westwind.Windows.wwTextBox txtEmail;

		/// <summary>
		///  Strongly typed Customer Object
		/// </summary>
		public Customer Customer = null;
		
		/// <summary>
		/// Weakly typed FoxPro Customer object
		/// </summary>
		public object FoxCustomer = null;


		public WinFormCom()
		{
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnSayHello = new System.Windows.Forms.Button();
			this.txtMessage = new Westwind.Windows.wwTextBox();
			this.Status = new System.Windows.Forms.StatusBar();
			this.Panel1 = new System.Windows.Forms.StatusBarPanel();
			this.txtName = new Westwind.Windows.wwTextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.txtCompany = new Westwind.Windows.wwTextBox();
			this.label3 = new System.Windows.Forms.Label();
			this.txtPhone = new Westwind.Windows.wwTextBox();
			this.label4 = new System.Windows.Forms.Label();
			this.txtAddress = new Westwind.Windows.wwTextBox();
			this.label5 = new System.Windows.Forms.Label();
			this.txtCreditLimit = new Westwind.Windows.wwTextBox();
			this.cmdSave = new System.Windows.Forms.Button();
			this.label6 = new System.Windows.Forms.Label();
			this.txtEmail = new Westwind.Windows.wwTextBox();
			((System.ComponentModel.ISupportInitialize)(this.Panel1)).BeginInit();
			this.SuspendLayout();
			// 
			// btnSayHello
			// 
			this.btnSayHello.Location = new System.Drawing.Point(9, 261);
			this.btnSayHello.Name = "btnSayHello";
			this.btnSayHello.Size = new System.Drawing.Size(99, 23);
			this.btnSayHello.TabIndex = 8;
			this.btnSayHello.Text = "Display Message";
			this.btnSayHello.Click += new System.EventHandler(this.btnSayHello_Click);
			// 
			// txtMessage
			// 
			this.txtMessage.BindingProperty = "Text";
			this.txtMessage.ControlSourceObject = null;
			this.txtMessage.ControlSourceProperty = "";
			this.txtMessage.Location = new System.Drawing.Point(10, 239);
			this.txtMessage.Name = "txtMessage";
			this.txtMessage.Size = new System.Drawing.Size(210, 20);
			this.txtMessage.TabIndex = 7;
			this.txtMessage.Text = "";
			// 
			// Status
			// 
			this.Status.Location = new System.Drawing.Point(0, 298);
			this.Status.Name = "Status";
			this.Status.Panels.AddRange(new System.Windows.Forms.StatusBarPanel[] {
																					  this.Panel1});
			this.Status.ShowPanels = true;
			this.Status.Size = new System.Drawing.Size(402, 27);
			this.Status.TabIndex = 2;
			// 
			// Panel1
			// 
			this.Panel1.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Spring;
			this.Panel1.Width = 386;
			// 
			// txtName
			// 
			this.txtName.BindingProperty = "Text";
			this.txtName.ControlSourceObject = "Customer";
			this.txtName.ControlSourceProperty = "Name";
			this.txtName.Location = new System.Drawing.Point(74, 30);
			this.txtName.Name = "txtName";
			this.txtName.Size = new System.Drawing.Size(293, 20);
			this.txtName.TabIndex = 0;
			this.txtName.Text = "";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 35);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(56, 14);
			this.label1.TabIndex = 4;
			this.label1.Text = "Name:";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 65);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(56, 14);
			this.label2.TabIndex = 6;
			this.label2.Text = "Company:";
			// 
			// txtCompany
			// 
			this.txtCompany.BindingProperty = "Text";
			this.txtCompany.ControlSourceObject = "Customer";
			this.txtCompany.ControlSourceProperty = "Company";
			this.txtCompany.Location = new System.Drawing.Point(74, 61);
			this.txtCompany.Name = "txtCompany";
			this.txtCompany.Size = new System.Drawing.Size(293, 20);
			this.txtCompany.TabIndex = 1;
			this.txtCompany.Text = "";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(8, 148);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(56, 14);
			this.label3.TabIndex = 10;
			this.label3.Text = "Phone:";
			// 
			// txtPhone
			// 
			this.txtPhone.BindingProperty = "Text";
			this.txtPhone.ControlSourceObject = "Customer.oAddress";
			this.txtPhone.ControlSourceProperty = "Phone";
			this.txtPhone.Location = new System.Drawing.Point(74, 141);
			this.txtPhone.Name = "txtPhone";
			this.txtPhone.Size = new System.Drawing.Size(293, 20);
			this.txtPhone.TabIndex = 3;
			this.txtPhone.Text = "";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(8, 89);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(56, 14);
			this.label4.TabIndex = 8;
			this.label4.Text = "Address:";
			// 
			// txtAddress
			// 
			this.txtAddress.BindingProperty = "Text";
			this.txtAddress.ControlSourceObject = "Customer.oAddress";
			this.txtAddress.ControlSourceProperty = "StreetAddress";
			this.txtAddress.Location = new System.Drawing.Point(74, 87);
			this.txtAddress.Multiline = true;
			this.txtAddress.Name = "txtAddress";
			this.txtAddress.Size = new System.Drawing.Size(293, 49);
			this.txtAddress.TabIndex = 2;
			this.txtAddress.Text = "";
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(8, 195);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(67, 12);
			this.label5.TabIndex = 12;
			this.label5.Text = "Credit Limit:";
			// 
			// txtCreditLimit
			// 
			this.txtCreditLimit.BindingProperty = "Text";
			this.txtCreditLimit.ControlSourceObject = "Customer";
			this.txtCreditLimit.ControlSourceProperty = "CreditLimit";
			this.txtCreditLimit.Location = new System.Drawing.Point(74, 194);
			this.txtCreditLimit.Name = "txtCreditLimit";
			this.txtCreditLimit.Size = new System.Drawing.Size(293, 20);
			this.txtCreditLimit.TabIndex = 5;
			this.txtCreditLimit.Text = "";
			// 
			// cmdSave
			// 
			this.cmdSave.Location = new System.Drawing.Point(290, 225);
			this.cmdSave.Name = "cmdSave";
			this.cmdSave.TabIndex = 6;
			this.cmdSave.Text = "Save";
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(8, 170);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(56, 14);
			this.label6.TabIndex = 15;
			this.label6.Text = "Email:";
			// 
			// txtEmail
			// 
			this.txtEmail.BindingProperty = "Text";
			this.txtEmail.ControlSourceObject = "Customer.oAddress";
			this.txtEmail.ControlSourceProperty = "Email";
			this.txtEmail.Location = new System.Drawing.Point(74, 165);
			this.txtEmail.Name = "txtEmail";
			this.txtEmail.Size = new System.Drawing.Size(293, 20);
			this.txtEmail.TabIndex = 4;
			this.txtEmail.Text = "";
			// 
			// WinFormCom
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(402, 325);
			this.Controls.Add(this.label6);
			this.Controls.Add(this.txtEmail);
			this.Controls.Add(this.txtCreditLimit);
			this.Controls.Add(this.txtPhone);
			this.Controls.Add(this.txtAddress);
			this.Controls.Add(this.txtCompany);
			this.Controls.Add(this.txtName);
			this.Controls.Add(this.txtMessage);
			this.Controls.Add(this.cmdSave);
			this.Controls.Add(this.label5);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.label4);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.Status);
			this.Controls.Add(this.btnSayHello);
			this.Name = "WinFormCom";
			this.StartPosition = System.Windows.Forms.FormStartPosition.Manual;
			this.Text = "WindowsFormSample";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.WinFormCom_Closing);
			((System.ComponentModel.ISupportInitialize)(this.Panel1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		private void btnSayHello_Click(object sender, System.EventArgs e)
		{
			this.DisplayMessage( this.txtName.Text );	
		}
		
		public void DisplayMessage(string Message)
		{
			this.Status.Panels[0].Text = Message;
			this.Refresh();
		}

		public void LoadFoxCustomer(object Customer) 
		{
			if (Customer == null)
				return;

			this.FoxCustomer = Customer;
			
			this.BindFoxData();								  
		}

		// *** Fox Object must manually bind because
		// *** we can only pass it in as 'object'
		public void BindFoxData() 
		{
			object Customer = this.FoxCustomer;

			// *** The hard way - using pure Reflection
			this.txtName.Text = (string)
				Customer.GetType().InvokeMember(
				"Name",  // Property Name
				BindingFlags.Instance | BindingFlags.GetProperty,
				null,   // Binder - not used
				Customer,  // Object to read from
				null );    // parameters (not used)

			// *** Retrieving using ComUtils
			this.txtCompany.Text = (string) 
				    ComUtils.GetProperty(Customer,"Company");

			this.txtCreditLimit.Text = 
					ComUtils.GetProperty(Customer,"CreditLimit").ToString();

			
			// *** Nested objects the hard way using Reflection
			// *** Start by retrievinig the Address object
			object Address = 
				Customer.GetType().InvokeMember(
				"oAddress",  // Property Name
				BindingFlags.Instance | BindingFlags.GetProperty,
				null,   // Binder - not used
				Customer,  // Object to read from
				null );    // parameters (not used)
			
			this.txtAddress.Text = (string)
				Address.GetType().InvokeMember(
					"StreetAddress",  // Property Name
					BindingFlags.Instance | BindingFlags.GetProperty,
					null,   // Binder - not used
					Address,  // Object to read from
					null );    // parameters (not used)

			// *** Using COM Utils
			Address = ComUtils.GetProperty(Customer,"oAddress");
			this.txtEmail.Text = (string) ComUtils.GetProperty(Address,"Email");

			// *** Or even easier:
			this.txtPhone.Text = (string) ComUtils.GetPropertyEx(Customer,"oAddress.Phone");
 		}

		public void UnbindFoxData() 
		{
			object Customer = this.FoxCustomer;

		}

		public void LoadCustomer(Customer Customer) 
		{
			if (Customer == null)
				return;

			this.Customer = Customer;
			this.BindData();		
			
		}

		public void BindData() 
		{
			Westwind.Windows.wwDataControlHelper.FormBindData(this);
		}
		public bool UnbindData() 
		{
			this.Customer.Name = this.txtName.Text;
			this.Customer.Company = this.txtCompany.Text;
			try 
			{
				this.Customer.CreditLimit = decimal.Parse( this.txtCreditLimit.Text);
			}
			catch 
			{
				MessageBox.Show("Invalid Credit Limit value");
				return false;
			}
				
			this.Customer.oAddress.StreetAddress = this.txtAddress.Text;
			this.Customer.oAddress.Email = this.txtEmail.Text;
			this.Customer.oAddress.Phone = this.txtPhone.Text;

			return true;
		}

		private void WinFormCom_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			Application.Exit();
		}


	}


	[ClassInterface(ClassInterfaceType.AutoDual)]
	[ProgId("DotNetCom.WinFormComFactory")]	
	public class WinFormComFactory
	{
		WinFormCom Instance = null;

		public WinFormCom RunForm() 
		{
			// Create instance on this thread so 
			// we can pass it back to caller
			this.Instance = new WinFormCom();

			System.Threading.Thread t = new System.Threading.Thread( 
				new ThreadStart( this.RunThread ) );

			t.ApartmentState = ApartmentState.STA;  // IMPORTANT!
			t.Start();

			return this.Instance;
		}

		public void RunThread() 
		{
			// Show the form
			this.Instance.Show();
			System.Windows.Forms.Application.Run(this.Instance);
		}
	}

}
